/* aix_obuffer.h

	Copied from obuffer_aix.h from maplay 1.3b */

/*
 *  @(#) obuffer_aix.h 1.1, last edit: 13 Feb 1995 13:13:06
 *  @(#) Copyright (C) 1993, 1994 Tobias Bading (bading@cs.tu-berlin.de)
 *  @(#) Berlin University of Technology
 *
 *  AixObuffer class written by
 *  Nick Cremelie (cremelie@ibmsp.elis.rug.ac.be)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef OBUFFER_AIX_H
#define OBUFFER_AIX_H

#ifdef AIX

#include "all.h"
#include "args.h"

class AixObuffer : public Obuffer
{
  int16  buffer[OBUFFERSIZE];
  int16 *bufferp[MAXCHANNELS];
  uint32 channels;
  static int audio_fd;

  static int open_audio_device (void);

public:
        AixObuffer (uint32 number_of_channels, MPEG_Args *mpeg_args);
       ~AixObuffer (void);
  void  append (uint32 channel, int16 value);
  void  write_buffer (int dummy);

#ifdef SEEK_STOP
  void AixObuffer::clear_buffer(void);

  void AixObuffer::set_stop_flag(void)
#endif // SEEK_STOP

  static BOOL class_suitable (uint32 number_of_channels);
};

#endif // AIX

#endif